package ri;

import java.io.*;
import java.net.*;
import java.util.*;
import java.sql.*;

public class SaveResult implements Runnable {
	//protected static String host="10.164.34.232";
	protected static int port=8090;
	protected static ServerSocket serverSoc;
	public static void main(String []args) {
		startServer();
	}
	public static void startServer() {
		try {
			serverSoc=new ServerSocket(port);
			int count=0;
			while (true) {
				Socket soc=serverSoc.accept();
				SaveResult sr=new SaveResult(soc);
				Thread thread=new Thread(sr);
				thread.start();
				//Thread.sleep(100);
				//System.out.println("count: "+count);
				count++;
			}
		} catch (Exception e) {e.printStackTrace();}
	}

	protected Socket clientSoc;
	public SaveResult(Socket soc) {clientSoc=soc;}
				
	/*public static void saveResult(String desc, String tm, String gs, int acc, String ns) {
		String user=getUser();
		try {
			Socket soc=new Socket(host, port);
			OutputStream os=soc.getOutputStream();
			PrintWriter pw=new PrintWriter(os);
			pw.println("Typing Test Application");
			pw.println(user);
			pw.println(desc);
			pw.println(tm);
			pw.println(gs);
			pw.println(acc);
			pw.println(ns);
			pw.close();
		} catch (Exception e) {e.printStackTrace();}
	}*/
	public void run() {
		try {
			InputStream is=clientSoc.getInputStream();
			BufferedReader br=new BufferedReader(new InputStreamReader(is));
			String header=br.readLine();
			if (header.equals("Typing Test Application")) {
				String user=br.readLine();
				String desc=br.readLine();
				String tm=br.readLine();
				String grossSpeed=br.readLine();
				String accuracy=br.readLine();
				String netSpeed=br.readLine();
				doSave(user, desc, tm, grossSpeed, accuracy, netSpeed);
				//System.out.println("Client Port: "+clientSoc.getPort());
			}
		} catch (Exception e) {e.printStackTrace();}
	}
	public void doSave(String user, String desc, String tm, String grossSpeed,
			String accuracy, String netSpeed) {
		user=truncate(user, 50);
		desc=truncate(desc, 60);
		long currTime=System.currentTimeMillis();
		try {
			System.out.println(new java.util.Date(currTime));
			System.out.println(user+"\t"+desc+"\t"+tm+"\t"+grossSpeed+"\t"+
				accuracy+"\t"+netSpeed);

			Connection conn=getConnection();
			String sql="insert into speedType (date, name, title, typeTime, grossSpeed, accuracy, "+
				"netSpeed) values (?, ?, ?, ?, ?, ?, ?)";
			PreparedStatement pstmt=conn.prepareStatement(sql);
			pstmt.setTimestamp(1, new Timestamp(currTime));
			pstmt.setString(2, user);
			pstmt.setString(3, desc);
			pstmt.setString(4, tm);
			pstmt.setString(5, grossSpeed);
			pstmt.setString(6, accuracy);
			pstmt.setString(7, netSpeed);
			pstmt.executeUpdate();
			pstmt.close();
			conn.close();
			//Exception ex=new Exception("doSave");
			//ex.printStackTrace();
		} catch (Exception e) {e.printStackTrace();}
	}
	public static Connection getConnection() {
		String sqlDrv=
			"jdbc:jtds:sqlserver://10.164.32.132/webdb;user=ri;password=";
		Connection conn=null;
		try {
			Driver driver=(Driver)Class.forName("net.sourceforge.jtds.jdbc.Driver").newInstance();
	                Properties dbProperty=new Properties();
        	        //dbProperty.put("password","");
			//dbProperty.put("TDS", "4.2");	// for SQL 6.5
                	//sqlCon=driver.connect("jdbc:jtds:sqlserver://rint1/sis_db;user=sa",dbProperty);
                	conn=driver.connect(sqlDrv,dbProperty);
		} catch (Exception e) {e.printStackTrace();}
		return conn;
	}
	public static String truncate(String str, int maxLen) {
		int len=str.length();
		if (len>maxLen)
			str=str.substring(0, maxLen);
		return str;
	}
}