package ngc.typetest;

import java.io.*;
import java.util.*;

/** this class manages the test texts that are loaded by the application
 * the files are to be found in the /data directory
 * the format of the configuration file /data/bookInfo.txt:
 * 	   filename|title: author|
 */
public class DocumentManager {
	protected Hashtable docHash=new Hashtable();
	protected Vector descVect=new Vector();
	public DocumentManager() {
		readFile("/data/bookInfo.txt");
	}
	public void readFile(String filename) {
		StringBuffer buffer=new StringBuffer();
		try {
			Class cl=getClass();
			InputStream is=cl.getResourceAsStream(filename);
			BufferedReader br=new BufferedReader(new InputStreamReader(is));
			String input;
			while ((input=br.readLine()) != null) {
				processLine(input);
			}
			br.close();
		} catch (Exception e) {e.printStackTrace();}
	}
	public void processLine(String input) {
		int loc1=input.indexOf("|");
		if (loc1<0)
			return;
		int loc2=input.indexOf("|", loc1+1);
		if (loc2<0)
			return;
		String filename=input.substring(0, loc1);
		String desc=input.substring(loc1+1, loc2);
		docHash.put(desc, filename);
		descVect.addElement(desc);
	}
	public Vector getDescription() {return descVect;}
	public String getFilename(String desc) {
		String file=(String)docHash.get(desc);
		if (file==null) {
			System.out.println("Not found: "+desc);
			return file;
		}
		String filename="/data/"+file;
		System.out.println(desc+" ["+filename+"]");
		return filename;
	}

}