package ngc.typetest;

import java.awt.*;

/** this class handles the typing statistics in real time
 */
public class StatPanel extends Panel implements Runnable {
	protected static StatPanel theStatPanel=new StatPanel();
	public static StatPanel getStatPanel() {return theStatPanel;}
	public static void reset() {theStatPanel.resetAux();}
	public static void initTimer() {theStatPanel.initTimerAux();}
	public static void stopTimer() {theStatPanel.stopTimerAux();}
	public static void setMaxTime(int tm) {theStatPanel.setMaxTimeAux(tm);}
	public static void set(String wdCount, String sp, String acc, String netSp) {
		theStatPanel.wordCountLabel.setText(wdCount);
		theStatPanel.speedLabel.setText(sp);
		theStatPanel.accuracyLabel.setText(acc);
		theStatPanel.netSpeedLabel.setText(netSp);
		theStatPanel.repaint();
	}
	protected TestArea testArea=null;
	protected boolean isTimerOn=false;
	protected int maxTime=900, timeLeft=maxTime;	// time in seconds
	protected Button endTest=null;
	protected Label clockLabel=new Label(formatTime());
	protected Label wordCountLabel=new Label("    0");
	protected Label speedLabel=new Label("      0");
	protected Label accuracyLabel=new Label("      0");
	protected Label netSpeedLabel=new Label("      0");
	public StatPanel() {
		GridLayout grid=new GridLayout(1,11);
		setLayout(grid);
		setSize(800,50);
		Label lab=new Label("Time Left");
		add(lab);
		add(clockLabel);
		lab=new Label("Words");
		add(lab);
		add(wordCountLabel);
		lab=new Label("Gross Spd");
		add(lab);
		add(speedLabel);
		lab=new Label("Accuracy");
		add(lab);
		add(accuracyLabel);
		lab=new Label("Net Spd");
		add(lab);
		add(netSpeedLabel);

		endTest=new Button("End Test");
		add(endTest);
	}
	public void setTestAction(TestArea ta) {
		TestAction tact=new TestAction(ta);
		endTest.addActionListener(tact);
	}
	public void resetAux() {
		clockLabel.setText(formatTime());
		wordCountLabel.setText("0");
		speedLabel.setText("0");
		accuracyLabel.setText("0");
		netSpeedLabel.setText("0");
	}
	public void run() {
		while (true) {
			if (isTimerOn) {
				setTime();
			}
			try {Thread.sleep(1000);} catch(Exception e){e.printStackTrace();}
		}
	}
	public void initTimerAux() {
		clockLabel.setText(formatTime());
		timeLeft=maxTime;
		isTimerOn=true;
	}
	public void setTime() {
		if (timeLeft<=0) {
			if (isTimerOn==true) {
				isTimerOn=false;
				testArea.endTest();
			}
			else {
				return;
			}
		}
		timeLeft--;
		int min=timeLeft/60;
		int sec=timeLeft%60;
		String timeStr=min+":"+sec;
		if (sec<10)
			timeStr=min+":0"+sec;
		clockLabel.setText(timeStr);
		testArea.setStatistics();
		repaint();
	}
	public void stopTimerAux() {isTimerOn=false;}
	public String formatTime() {
		int min=maxTime/60;
		int sec=maxTime%60;
		String timeStr=min+":"+sec;
		if (sec<10)
			timeStr=min+":0"+sec;
		return timeStr;
	}
	public void setMaxTimeAux(int mt) {maxTime=mt;}
	public void setTestArea(TestArea ta) {testArea=ta;}
}