package ngc.typetest;

import java.io.*;
import java.net.*;
import java.util.*;

/** this class handles the communication with a server.
 *  test results are sent to the server
 */

public class StoreResult {
	protected static String typingTestUser=null;
	public static void setUser(String user) {typingTestUser=user;}
	protected static String host="localhost";
	protected static int port=8090;
	public static void saveResult(String desc, long tm, float gs, float acc, float ns) {
		// disabled as server not present
		if (true)
			return;
		if (tm<240)
			return;
		if (desc.equals("own file"))
			return;
		String user=getUser();
		if (user.trim().toUpperCase().equals("UNKNOWN"))
			return;
		try {
			Socket soc=new Socket(host, port);
			OutputStream os=soc.getOutputStream();
			PrintWriter pw=new PrintWriter(os);
			pw.println("Typing Test Application");
			pw.println(user);
			pw.println(desc);
			pw.println(tm);
			pw.println(gs);
			pw.println(acc);
			pw.println(ns);
			pw.close();
		} catch (Exception e) {e.printStackTrace();}
	}
	public static String getUser() {
		if (typingTestUser==null)
			typingTestUser=getUserAux();
		return typingTestUser;
	}
	public static String getUserAux() {
                Properties prop=System.getProperties();
                String user=prop.getProperty("user.name");
                System.out.println(user);
		checkUser(user);
                return user;
	}
	public static void checkUser(String user) {
		if (user==null || user.trim().toUpperCase().equals("UNKNOWN")) {
			System.out.println("***********************************");
			System.out.println("***********************************");
			System.out.println("* You have not logged in properly *");
			System.out.println("* Please log out and log in again  *");
			System.out.println("***********************************");
			System.out.println("***********************************");
			System.exit(1);
		}
	}
	public static void showProperty(Properties prop) {
		Enumeration enum=prop.keys();
		while (enum.hasMoreElements()) {
			String key=(String)enum.nextElement();
			String val=(String)prop.get(key);
			System.out.println(key+": "+val);
		}
	}
}
