package ngc.typetest;

import java.awt.*;
import java.awt.event.*;
import java.io.*;

/** this class displays the test document.  It tries to keep the current word in
 *  the middle of the display area 
 *  Note:  if there are many short lines, this would not work properly
 */

public class TestDocument extends TextArea {
	protected int lastSpace=0;
	protected String filename="/data/aitcs10.txt";
	public TestDocument() {
		super("Default Text", 16, 80, TextArea.SCROLLBARS_VERTICAL_ONLY);
		setEditable(false);
		enableEvents(AWTEvent.MOUSE_EVENT_MASK);
	}
	public void processMouseEvent(MouseEvent evt) {
		evt.consume();
	}

	public void readFile(String file) {
		filename=file;
		StringBuffer buffer=new StringBuffer();
		String allText="Default Text";
		try {
			Class cl=getClass();
			InputStream is=cl.getResourceAsStream(filename);
			BufferedReader br=new BufferedReader(new InputStreamReader(is));
			String input;
			while ((input=br.readLine()) != null) {
				buffer.append(input+"\n");
			}
			br.close();
			allText=buffer.toString();
		} catch (Exception e) {e.printStackTrace();}
		setText(allText);
	}
	public void readFile99(String file) {
		filename=file;
		StringBuffer buffer=new StringBuffer();
		String allText="Default Text";
		try {
			BufferedReader br=new BufferedReader(new FileReader(filename));
			String input;
			while ((input=br.readLine()) != null) {
				buffer.append(input+"\n");
			}
			br.close();
			allText=buffer.toString();
		} catch (Exception e) {e.printStackTrace();}
		setText(allText);
	}
	public String getFirstWord() {
		String text=getText();
		lastSpace=text.indexOf(" ");
		String word=text.substring(0, lastSpace).trim();
		select(0, lastSpace);
		return word;
	}
	public String getNextWord() {
		if (lastSpace<0)
			return null;
		String text=getText();
		int len=text.length();
		int nextLoc=lastSpace+1;
		if (nextLoc>=len) {
			select(len-1, len-1);
			return null;
		}
		StringBuffer wordBuf=new StringBuffer();
		int currLoc=nextLoc;
		while (currLoc<len) {
			lastSpace=currLoc;
			char ch=text.charAt(currLoc);
			currLoc++;
			if (Character.isWhitespace(ch))
				break;
			else {
				wordBuf.append(ch);
			}
		}
		String word=wordBuf.toString();
		if (word.length()>0) {
			if (nextLoc+388<len)
				select(nextLoc+388, nextLoc+388);
			select(nextLoc, lastSpace);
			return word;
		}
		else return getNextWord();
	}
	public void changeFont() {
		Font currFont=getFont();
		System.out.println(currFont.getSize()+"\t"+currFont.getName());
		Font newFont=currFont.deriveFont(Font.BOLD, 15.0f);
		setFont(newFont);
	}
	public String getFilename() {return filename;}
}