package ngc.typetest;

import java.awt.*;
import java.util.*;

/** need to port this class to use Panel & Table instead of third party library
 */

public class TestResult extends Panel {
	protected static TestResult theResult=new TestResult();
	protected static Panel getResultPanel() {return theResult;}
	public TestResult() {
		   //String header=formatResult("Description", "Time/min:sec", "Gross Speed/wpm",
		   //		  "Accuracy/%", "Net Speed/wpm");
		   String header=formatResult("Description", "Time", "Gross Sp",
		   		  "Acc/%", "Net Sp");
		   Label headerLabel=new Label(header);
		   changeFont(headerLabel);
		   add(headerLabel);
	}	
	public static void addResult(String desc, String tm, String gs, int acc, String ns) {
		   String result=formatResult(desc, tm, gs, ""+acc, ns);
		   Label resultLabel=new Label(result);
		   theResult.changeFont(resultLabel);
		   theResult.add(resultLabel);
	}
	public static String formatResult(String desc, String tm, String gs, String acc, String ns) {
		   int floatLen=10;
		   int intLen=floatLen-2;
		   return rightPad(desc, 35)+leftPad(tm, floatLen) + leftPad(gs, floatLen)+
		   		  leftPad(acc, intLen)+leftPad(ns, floatLen);
	}
	public static String leftPad(String str, int len) {
		   int strLen=str.length();
		   String blank="                                                    ";
		   String result=str;
		   if (strLen<len)
		   	  result=blank.substring(0, (len-strLen))+str;
		   return result;
    }
	public static String rightPad(String str, int len) {
		   int strLen=str.length();
		   String blank="                                                    ";
		   String result=str;
		   if (strLen<len)
		   	  result=str+blank.substring(0, (len-strLen));
			  else if (strLen>len)
			  result=str.substring(0,len-3)+"...";
		   return result;
    }
	// need to use proportional font so that text is aligned in the result table
	public void changeFont(Component comp) {
		Font newFont=new Font("Courier", Font.PLAIN, 12);
		comp.setFont(newFont);
	}
}

